diff --git a/gcc/cp/call.c b/gcc/cp/call.c
index 121f0ca..d781980 100644
--- a/gcc/cp/call.c
+++ b/gcc/cp/call.c
@@ -162,12 +162,14 @@ static tree build_over_call (struct z_candidate *, int, tsubst_flags_t);
 		     /*c_cast_p=*/false, (COMPLAIN))
 static tree convert_like_real (conversion *, tree, tree, int, bool,
 			       bool, tsubst_flags_t);
-static void op_error (location_t, enum tree_code, enum tree_code, tree,
-		      tree, tree, bool);
+static void op_error (diagnostic_group *, location_t, enum tree_code,
+		      enum tree_code, tree, tree, tree, bool);
 static struct z_candidate *build_user_type_conversion_1 (tree, tree, int,
 							 tsubst_flags_t);
-static void print_z_candidate (location_t, const char *, struct z_candidate *);
-static void print_z_candidates (location_t, struct z_candidate *);
+static void print_z_candidate (diagnostic_group *, location_t, const char *,
+			       struct z_candidate *);
+static void print_z_candidates (diagnostic_group *, location_t,
+				struct z_candidate *);
 static tree build_this (tree);
 static struct z_candidate *splice_viable (struct z_candidate *, bool, bool *);
 static bool any_strictly_viable (struct z_candidate *);
@@ -3429,7 +3431,8 @@ equal_functions (tree fn1, tree fn2)
 /* Print information about a candidate being rejected due to INFO.  */
 
 static void
-print_conversion_rejection (location_t loc, struct conversion_info *info)
+print_conversion_rejection (diagnostic_group *group, location_t loc,
+			    struct conversion_info *info)
 {
   tree from = info->from;
   if (!TYPE_P (from))
@@ -3439,41 +3442,42 @@ print_conversion_rejection (location_t loc, struct conversion_info *info)
       /* Conversion of implicit `this' argument failed.  */
       if (!TYPE_P (info->from))
 	/* A bad conversion for 'this' must be discarding cv-quals.  */
-	inform (loc, "  passing %qT as %<this%> "
-		"argument discards qualifiers",
-		from);
+	group->inform (loc, "  passing %qT as %<this%> "
+		       "argument discards qualifiers",
+		       from);
       else
-	inform (loc, "  no known conversion for implicit "
-		"%<this%> parameter from %qH to %qI",
-		from, info->to_type);
+	group->inform (loc, "  no known conversion for implicit "
+		       "%<this%> parameter from %qH to %qI",
+		       from, info->to_type);
     }
   else if (!TYPE_P (info->from))
     {
       if (info->n_arg >= 0)
-	inform (loc, "  conversion of argument %d would be ill-formed:",
-		info->n_arg + 1);
+	group->inform (loc, "  conversion of argument %d would be ill-formed:",
+		       info->n_arg + 1);
       perform_implicit_conversion (info->to_type, info->from,
 				   tf_warning_or_error);
     }
   else if (info->n_arg == -2)
     /* Conversion of conversion function return value failed.  */
-    inform (loc, "  no known conversion from %qH to %qI",
-	    from, info->to_type);
+    group->inform (loc, "  no known conversion from %qH to %qI",
+		   from, info->to_type);
   else
-    inform (loc, "  no known conversion for argument %d from %qH to %qI",
-	    info->n_arg + 1, from, info->to_type);
+    group->inform (loc, "  no known conversion for argument %d from %qH to %qI",
+		   info->n_arg + 1, from, info->to_type);
 }
 
 /* Print information about a candidate with WANT parameters and we found
    HAVE.  */
 
 static void
-print_arity_information (location_t loc, unsigned int have, unsigned int want)
+print_arity_information (diagnostic_group *group, location_t loc,
+			 unsigned int have, unsigned int want)
 {
-  inform_n (loc, want,
-	    "  candidate expects %d argument, %d provided",
-	    "  candidate expects %d arguments, %d provided",
-	    want, have);
+  group->inform_n (loc, want,
+		   "  candidate expects %d argument, %d provided",
+		   "  candidate expects %d arguments, %d provided",
+		   want, have);
 }
 
 /* Print information about one overload candidate CANDIDATE.  MSGSTR
@@ -3484,7 +3488,7 @@ print_arity_information (location_t loc, unsigned int have, unsigned int want)
    life simpler in print_z_candidates and for the translators.  */
 
 static void
-print_z_candidate (location_t loc, const char *msgstr,
+print_z_candidate (diagnostic_group *group, location_t loc, const char *msgstr,
 		   struct z_candidate *candidate)
 {
   const char *msg = (msgstr == NULL
@@ -3499,30 +3503,30 @@ print_z_candidate (location_t loc, const char *msgstr,
     {
       cloc = loc;
       if (candidate->num_convs == 3)
-	inform (cloc, "%s%<%D(%T, %T, %T)%> <built-in>", msg, fn,
-		candidate->convs[0]->type,
-		candidate->convs[1]->type,
-		candidate->convs[2]->type);
+	group->inform (cloc, "%s%<%D(%T, %T, %T)%> <built-in>", msg, fn,
+		       candidate->convs[0]->type,
+		       candidate->convs[1]->type,
+		       candidate->convs[2]->type);
       else if (candidate->num_convs == 2)
-	inform (cloc, "%s%<%D(%T, %T)%> <built-in>", msg, fn,
-		candidate->convs[0]->type,
-		candidate->convs[1]->type);
+	group->inform (cloc, "%s%<%D(%T, %T)%> <built-in>", msg, fn,
+		       candidate->convs[0]->type,
+		       candidate->convs[1]->type);
       else
-	inform (cloc, "%s%<%D(%T)%> <built-in>", msg, fn,
-		candidate->convs[0]->type);
+	group->inform (cloc, "%s%<%D(%T)%> <built-in>", msg, fn,
+		       candidate->convs[0]->type);
     }
   else if (TYPE_P (fn))
-    inform (cloc, "%s%qT <conversion>", msg, fn);
+    group->inform (cloc, "%s%qT <conversion>", msg, fn);
   else if (candidate->viable == -1)
-    inform (cloc, "%s%#qD <near match>", msg, fn);
+    group->inform (cloc, "%s%#qD <near match>", msg, fn);
   else if (DECL_DELETED_FN (fn))
-    inform (cloc, "%s%#qD <deleted>", msg, fn);
+    group->inform (cloc, "%s%#qD <deleted>", msg, fn);
   else
-    inform (cloc, "%s%#qD", msg, fn);
+    group->inform (cloc, "%s%#qD", msg, fn);
   if (fn != candidate->fn)
     {
       cloc = location_of (candidate->fn);
-      inform (cloc, "  inherited here");
+      group->inform (cloc, "  inherited here");
     }
   /* Give the user some information about why this candidate failed.  */
   if (candidate->reason != NULL)
@@ -3532,26 +3536,27 @@ print_z_candidate (location_t loc, const char *msgstr,
       switch (r->code)
 	{
 	case rr_arity:
-	  print_arity_information (cloc, r->u.arity.actual,
+	  print_arity_information (group, cloc, r->u.arity.actual,
 				   r->u.arity.expected);
 	  break;
 	case rr_arg_conversion:
-	  print_conversion_rejection (cloc, &r->u.conversion);
+	  print_conversion_rejection (group, cloc, &r->u.conversion);
 	  break;
 	case rr_bad_arg_conversion:
-	  print_conversion_rejection (cloc, &r->u.bad_conversion);
+	  print_conversion_rejection (group, cloc, &r->u.bad_conversion);
 	  break;
 	case rr_explicit_conversion:
-	  inform (cloc, "  return type %qT of explicit conversion function "
-		  "cannot be converted to %qT with a qualification "
-		  "conversion", r->u.conversion.from,
-		  r->u.conversion.to_type);
+	  group->inform (cloc,
+			 "  return type %qT of explicit conversion function "
+			 "cannot be converted to %qT with a qualification "
+			 "conversion", r->u.conversion.from,
+			 r->u.conversion.to_type);
 	  break;
 	case rr_template_conversion:
-	  inform (cloc, "  conversion from return type %qT of template "
-		  "conversion function specialization to %qT is not an "
-		  "exact match", r->u.conversion.from,
-		  r->u.conversion.to_type);
+	  group->inform (cloc, "  conversion from return type %qT of template "
+			 "conversion function specialization to %qT is not an "
+			 "exact match", r->u.conversion.from,
+			 r->u.conversion.to_type);
 	  break;
 	case rr_template_unification:
 	  /* We use template_unification_error_rejection if unification caused
@@ -3559,12 +3564,15 @@ print_z_candidate (location_t loc, const char *msgstr,
 	     them here.  */
 	  if (r->u.template_unification.tmpl == NULL_TREE)
 	    {
-	      inform (cloc, "  substitution of deduced template arguments "
-		      "resulted in errors seen above");
+	      group->inform (cloc,
+			     "  substitution of deduced template arguments "
+			     "resulted in errors seen above");
 	      break;
 	    }
 	  /* Re-run template unification with diagnostics.  */
-	  inform (cloc, "  template argument deduction/substitution failed:");
+	  group->inform (cloc,
+			 "  template argument deduction/substitution failed:");
+	  // FIXME: use group?
 	  fn_type_unification (r->u.template_unification.tmpl,
 			       r->u.template_unification.explicit_targs,
 			       (make_tree_vec
@@ -3577,21 +3585,22 @@ print_z_candidate (location_t loc, const char *msgstr,
 			       NULL, true, false);
 	  break;
 	case rr_invalid_copy:
-	  inform (cloc,
-		  "  a constructor taking a single argument of its own "
-		  "class type is invalid");
+	  group->inform (cloc,
+			 "  a constructor taking a single argument of its own "
+			 "class type is invalid");
 	  break;
 	case rr_constraint_failure:
 	  {
 	    tree tmpl = r->u.template_instantiation.tmpl;
 	    tree args = r->u.template_instantiation.targs;
-	    diagnose_constraints (cloc, tmpl, args);
+	    diagnose_constraints (group, cloc, tmpl, args);
 	  }
 	  break;
 	case rr_inherited_ctor:
-	  inform (cloc, "  an inherited constructor is not a candidate for "
-		  "initialization from an expression of the same or derived "
-		  "type");
+	  group->inform (cloc,
+			 "  an inherited constructor is not a candidate for "
+			 "initialization from an expression of the same or "
+			 "derived type");
 	  break;
 	case rr_none:
 	default:
@@ -3603,7 +3612,8 @@ print_z_candidate (location_t loc, const char *msgstr,
 }
 
 static void
-print_z_candidates (location_t loc, struct z_candidate *candidates)
+print_z_candidates (diagnostic_group * group, location_t loc,
+		    struct z_candidate *candidates)
 {
   struct z_candidate *cand1;
   struct z_candidate **cand2;
@@ -3649,7 +3659,7 @@ print_z_candidates (location_t loc, struct z_candidate *candidates)
     }
 
   for (; candidates; candidates = candidates->next)
-    print_z_candidate (loc, "candidate:", candidates);
+    print_z_candidate (group, loc, "candidate:", candidates);
 }
 
 /* USER_SEQ is a user-defined conversion sequence, beginning with a
@@ -3964,9 +3974,10 @@ build_user_type_conversion_1 (tree totype, tree expr, int flags,
     {
       if (complain & tf_error)
 	{
-	  error ("conversion from %qH to %qI is ambiguous",
-		 fromtype, totype);
-	  print_z_candidates (location_of (expr), candidates);
+	  diagnostic_group d;
+	  d.error ("conversion from %qH to %qI is ambiguous",
+		   fromtype, totype);
+	  print_z_candidates (&d, location_of (expr), candidates);
 	}
 
       cand = candidates;	/* any one will do */
@@ -4267,14 +4278,15 @@ print_error_for_call_failure (tree fn, vec<tree, va_gc> *args,
   if (targs)
     name = lookup_template_function (name, targs);
 
+  diagnostic_group d;
   if (!any_strictly_viable (candidates))
-    error_at (loc, "no matching function for call to %<%D(%A)%>",
-	      name, build_tree_list_vec (args));
+    d.error_at (loc, "no matching function for call to %<%D(%A)%>",
+		name, build_tree_list_vec (args));
   else
-    error_at (loc, "call of overloaded %<%D(%A)%> is ambiguous",
-	      name, build_tree_list_vec (args));
+    d.error_at (loc, "call of overloaded %<%D(%A)%> is ambiguous",
+		name, build_tree_list_vec (args));
   if (candidates)
-    print_z_candidates (loc, candidates);
+    print_z_candidates (&d, loc, candidates);
 }
 
 /* Return an expression for a call to FN (a namespace-scope function,
@@ -4577,9 +4589,10 @@ build_op_call_1 (tree obj, vec<tree, va_gc> **args, tsubst_flags_t complain)
     {
       if (complain & tf_error)
         {
-          error ("no match for call to %<(%T) (%A)%>", TREE_TYPE (obj),
-		 build_tree_list_vec (*args));
-          print_z_candidates (location_of (TREE_TYPE (obj)), candidates);
+	  diagnostic_group d;
+	  d.error ("no match for call to %<(%T) (%A)%>", TREE_TYPE (obj),
+		   build_tree_list_vec (*args));
+          print_z_candidates (&d, location_of (TREE_TYPE (obj)), candidates);
         }
       result = error_mark_node;
     }
@@ -4590,9 +4603,11 @@ build_op_call_1 (tree obj, vec<tree, va_gc> **args, tsubst_flags_t complain)
 	{
           if (complain & tf_error)
             {
-              error ("call of %<(%T) (%A)%> is ambiguous", 
-                     TREE_TYPE (obj), build_tree_list_vec (*args));
-              print_z_candidates (location_of (TREE_TYPE (obj)), candidates);
+	      diagnostic_group d;
+	      d.error ("call of %<(%T) (%A)%> is ambiguous",
+		       TREE_TYPE (obj), build_tree_list_vec (*args));
+	      print_z_candidates (&d, location_of (TREE_TYPE (obj)),
+				  candidates);
             }
 	  result = error_mark_node;
 	}
@@ -4656,7 +4671,8 @@ op_error_string (const char *errmsg, int ntypes, bool match)
 }
 
 static void
-op_error (location_t loc, enum tree_code code, enum tree_code code2,
+op_error (diagnostic_group *group, location_t loc, enum tree_code code,
+	  enum tree_code code2,
 	  tree arg1, tree arg2, tree arg3, bool match)
 {
   bool assop = code == MODIFY_EXPR;
@@ -4666,65 +4682,73 @@ op_error (location_t loc, enum tree_code code, enum tree_code code2,
     {
     case COND_EXPR:
       if (flag_diagnostics_show_caret)
-	error_at (loc, op_error_string (G_("ternary %<operator?:%>"),
-					3, match),
-		  TREE_TYPE (arg1), TREE_TYPE (arg2), TREE_TYPE (arg3));
+	group->error_at (loc, op_error_string (G_("ternary %<operator?:%>"),
+					       3, match),
+			 TREE_TYPE (arg1), TREE_TYPE (arg2), TREE_TYPE (arg3));
       else
-	error_at (loc, op_error_string (G_("ternary %<operator?:%> "
-					   "in %<%E ? %E : %E%>"), 3, match),
-		  arg1, arg2, arg3,
-		  TREE_TYPE (arg1), TREE_TYPE (arg2), TREE_TYPE (arg3));
+	group->error_at (loc, op_error_string (G_("ternary %<operator?:%> "
+						  "in %<%E ? %E : %E%>"),
+					       3, match),
+			 arg1, arg2, arg3,
+			 TREE_TYPE (arg1), TREE_TYPE (arg2), TREE_TYPE (arg3));
       break;
 
     case POSTINCREMENT_EXPR:
     case POSTDECREMENT_EXPR:
       if (flag_diagnostics_show_caret)
-	error_at (loc, op_error_string (G_("%<operator%s%>"), 1, match),
-		  opname, TREE_TYPE (arg1));
+	group->error_at (loc, op_error_string (G_("%<operator%s%>"), 1, match),
+			 opname, TREE_TYPE (arg1));
       else
-	error_at (loc, op_error_string (G_("%<operator%s%> in %<%E%s%>"),
-					1, match),
-		  opname, arg1, opname, TREE_TYPE (arg1));
+	group->error_at (loc, op_error_string (G_("%<operator%s%> in %<%E%s%>"),
+					       1, match),
+			 opname, arg1, opname, TREE_TYPE (arg1));
       break;
 
     case ARRAY_REF:
       if (flag_diagnostics_show_caret)
-	error_at (loc, op_error_string (G_("%<operator[]%>"), 2, match),
-		  TREE_TYPE (arg1), TREE_TYPE (arg2));
+	group->error_at (loc, op_error_string (G_("%<operator[]%>"), 2, match),
+			 TREE_TYPE (arg1), TREE_TYPE (arg2));
       else
-	error_at (loc, op_error_string (G_("%<operator[]%> in %<%E[%E]%>"),
-					2, match),
-		  arg1, arg2, TREE_TYPE (arg1), TREE_TYPE (arg2));
+	group->error_at (loc,
+			 op_error_string (G_("%<operator[]%> in %<%E[%E]%>"),
+					  2, match),
+			 arg1, arg2, TREE_TYPE (arg1), TREE_TYPE (arg2));
       break;
 
     case REALPART_EXPR:
     case IMAGPART_EXPR:
       if (flag_diagnostics_show_caret)
-	error_at (loc, op_error_string (G_("%qs"), 1, match),
-		  opname, TREE_TYPE (arg1));
+	group->error_at (loc, op_error_string (G_("%qs"), 1, match),
+			 opname, TREE_TYPE (arg1));
       else
-	error_at (loc, op_error_string (G_("%qs in %<%s %E%>"), 1, match),
-		  opname, opname, arg1, TREE_TYPE (arg1));
+	group->error_at (loc, op_error_string (G_("%qs in %<%s %E%>"), 1,
+					       match),
+			 opname, opname, arg1, TREE_TYPE (arg1));
       break;
 
     default:
       if (arg2)
 	if (flag_diagnostics_show_caret)
-	  error_at (loc, op_error_string (G_("%<operator%s%>"), 2, match),
-		    opname, TREE_TYPE (arg1), TREE_TYPE (arg2));
+	  group->error_at (loc, op_error_string (G_("%<operator%s%>"), 2,
+						 match),
+			   opname, TREE_TYPE (arg1), TREE_TYPE (arg2));
 	else
-	  error_at (loc, op_error_string (G_("%<operator%s%> in %<%E %s %E%>"),
-					  2, match),
+	  group->error_at (loc,
+			   op_error_string (G_("%<operator%s%> in "
+					       "%<%E %s %E%>"),
+					    2, match),
 		    opname, arg1, opname, arg2,
 		    TREE_TYPE (arg1), TREE_TYPE (arg2));
       else
 	if (flag_diagnostics_show_caret)
-	  error_at (loc, op_error_string (G_("%<operator%s%>"), 1, match),
-		    opname, TREE_TYPE (arg1));
+	  group->error_at (loc, op_error_string (G_("%<operator%s%>"), 1,
+						 match),
+			   opname, TREE_TYPE (arg1));
 	else
-	  error_at (loc, op_error_string (G_("%<operator%s%> in %<%s%E%>"),
-					  1, match),
-		    opname, opname, arg1, TREE_TYPE (arg1));
+	  group->error_at (loc,
+			   op_error_string (G_("%<operator%s%> in %<%s%E%>"),
+					    1, match),
+			   opname, opname, arg1, TREE_TYPE (arg1));
       break;
     }
 }
@@ -5216,8 +5240,9 @@ build_conditional_expr_1 (location_t loc, tree arg1, tree arg2, tree arg3,
 	{
           if (complain & tf_error)
             {
-              op_error (loc, COND_EXPR, NOP_EXPR, arg1, arg2, arg3, FALSE);
-              print_z_candidates (loc, candidates);
+	      diagnostic_group d;
+	      op_error (&d, loc, COND_EXPR, NOP_EXPR, arg1, arg2, arg3, FALSE);
+	      print_z_candidates (&d, loc, candidates);
             }
 	  return error_mark_node;
 	}
@@ -5847,8 +5872,9 @@ build_new_op_1 (location_t loc, enum tree_code code, int flags, tree arg1,
 		  {
 		    /* ... Otherwise, report the more generic
 		       "no matching operator found" error */
-		    op_error (loc, code, code2, arg1, arg2, arg3, FALSE);
-		    print_z_candidates (loc, candidates);
+		    diagnostic_group d;
+		    op_error (&d, loc, code, code2, arg1, arg2, arg3, FALSE);
+		    print_z_candidates (&d, loc, candidates);
 		  }
 	    }
 	  result = error_mark_node;
@@ -5862,8 +5888,9 @@ build_new_op_1 (location_t loc, enum tree_code code, int flags, tree arg1,
 	{
 	  if (complain & tf_error)
 	    {
-	      op_error (loc, code, code2, arg1, arg2, arg3, TRUE);
-	      print_z_candidates (loc, candidates);
+	      diagnostic_group d;
+	      op_error (&d, loc, code, code2, arg1, arg2, arg3, TRUE);
+	      print_z_candidates (&d, loc, candidates);
 	    }
 	  result = error_mark_node;
 	}
@@ -6298,23 +6325,27 @@ build_op_delete_call (enum tree_code code, tree addr, tree size,
 	     -Wc++14-compat.  */
 	  else if (!flag_sized_deallocation)
 	    {
-	      if ((complain & tf_warning)
-		  && warning (OPT_Wc__14_compat, msg1))
-		inform (DECL_SOURCE_LOCATION (fn), msg2, fn);
+	      if ((complain & tf_warning))
+		{
+		  diagnostic_group d;
+		  if (d.warning (OPT_Wc__14_compat, msg1))
+		    d.inform (DECL_SOURCE_LOCATION (fn), msg2, fn);
+		}
 	      goto ok;
 	    }
 
 	  if (complain & tf_warning_or_error)
 	    {
-	      if (permerror (input_location, msg1))
+	      diagnostic_group d;
+	      if (d.permerror (input_location, msg1))
 		{
 		  /* Only mention C++14 for namespace-scope delete.  */
 		  if (DECL_NAMESPACE_SCOPE_P (fn))
-		    inform (DECL_SOURCE_LOCATION (fn), msg2, fn);
+		    d.inform (DECL_SOURCE_LOCATION (fn), msg2, fn);
 		  else
-		    inform (DECL_SOURCE_LOCATION (fn),
-			    "%qD is a usual (non-placement) deallocation "
-			    "function", fn);
+		    d.inform (DECL_SOURCE_LOCATION (fn),
+			      "%qD is a usual (non-placement) deallocation "
+			      "function", fn);
 		}
 	    }
 	  else
@@ -6612,13 +6643,13 @@ conversion_null_warnings (tree totype, tree expr, tree fn, int argnum)
    which user-defined conversion.  */
 
 static void
-maybe_print_user_conv_context (conversion *convs)
+maybe_print_user_conv_context (diagnostic_group *group, conversion *convs)
 {
   if (convs->user_conv_p)
     for (conversion *t = convs; t; t = next_conversion (t))
       if (t->kind == ck_user)
 	{
-	  print_z_candidate (0, "  after user-defined conversion:",
+	  print_z_candidate (group, 0, "  after user-defined conversion:",
 			     t->cand);
 	  break;
 	}
@@ -6709,11 +6740,12 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	{
 	  if (t->kind == ck_user && t->cand->reason)
 	    {
-	      complained = permerror (loc, "invalid user-defined conversion "
-				      "from %qH to %qI", TREE_TYPE (expr),
-				      totype);
+	      diagnostic_group d;
+	      complained = d.permerror (loc, "invalid user-defined conversion "
+					"from %qH to %qI", TREE_TYPE (expr),
+					totype);
 	      if (complained)
-		print_z_candidate (loc, "candidate is:", t->cand);
+		print_z_candidate (&d, loc, "candidate is:", t->cand);
 	      expr = convert_like_real (t, expr, fn, argnum,
 					/*issue_conversion_warnings=*/false,
 					/*c_cast_p=*/false,
@@ -6725,8 +6757,8 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	      else
 		expr = cp_convert (totype, expr, complain);
 	      if (complained && fn)
-		inform (DECL_SOURCE_LOCATION (fn),
-			"  initializing argument %P of %qD", argnum, fn);
+		d.inform (DECL_SOURCE_LOCATION (fn),
+			  "  initializing argument %P of %qD", argnum, fn);
 	      return expr;
 	    }
 	  else if (t->kind == ck_user || !t->bad_p)
@@ -6787,11 +6819,13 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	    if (CONSTRUCTOR_NELTS (expr) == 0
 		&& FUNCTION_FIRST_USER_PARMTYPE (convfn) != void_list_node)
 	      {
-		if (pedwarn (loc, 0, "converting to %qT from initializer list "
-			     "would use explicit constructor %qD",
-			     totype, convfn))
-		  inform (loc, "in C++11 and above a default constructor "
-			  "can be explicit");
+		diagnostic_group d;
+		if (d.pedwarn (loc, 0,
+			       "converting to %qT from initializer list "
+			       "would use explicit constructor %qD",
+			       totype, convfn))
+		  d.inform (loc, "in C++11 and above a default constructor "
+			    "can be explicit");
 	      }
 	    else
 	      error ("converting to %qT from initializer list would use "
@@ -6965,10 +6999,11 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	{
 	  if (complain & tf_error)
 	    {
-	      maybe_print_user_conv_context (convs);
+	      diagnostic_group d;
+	      maybe_print_user_conv_context (&d, convs);
 	      if (fn)
-		inform (DECL_SOURCE_LOCATION (fn),
-			"  initializing argument %P of %qD", argnum, fn);
+		d.inform (DECL_SOURCE_LOCATION (fn),
+			  "  initializing argument %P of %qD", argnum, fn);
 	    }
 	  return error_mark_node;
 	}
@@ -7017,10 +7052,11 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
       expr = build_temp (expr, totype, flags, &diag_kind, complain);
       if (diag_kind && complain)
 	{
-	  maybe_print_user_conv_context (convs);
+	  diagnostic_group d;
+	  maybe_print_user_conv_context (&d, convs);
 	  if (fn)
-	    inform (DECL_SOURCE_LOCATION (fn),
-		    "  initializing argument %P of %qD", argnum, fn);
+	    d.inform (DECL_SOURCE_LOCATION (fn),
+		      "  initializing argument %P of %qD", argnum, fn);
 	}
 
       return build_cplus_new (totype, expr, complain);
@@ -7032,23 +7068,24 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	if (convs->bad_p && !next_conversion (convs)->bad_p)
 	  {
 	    tree extype = TREE_TYPE (expr);
+	    diagnostic_group d;
 	    if (TYPE_REF_IS_RVALUE (ref_type)
 		&& lvalue_p (expr))
-	      error_at (loc, "cannot bind rvalue reference of type %qH to "
-                        "lvalue of type %qI", totype, extype);
+	      d.error_at (loc, "cannot bind rvalue reference of type %qH to "
+			  "lvalue of type %qI", totype, extype);
 	    else if (!TYPE_REF_IS_RVALUE (ref_type) && !lvalue_p (expr)
 		     && !CP_TYPE_CONST_NON_VOLATILE_P (TREE_TYPE (ref_type)))
-	      error_at (loc, "cannot bind non-const lvalue reference of "
-			"type %qH to an rvalue of type %qI", totype, extype);
+	      d.error_at (loc, "cannot bind non-const lvalue reference of "
+			  "type %qH to an rvalue of type %qI", totype, extype);
 	    else if (!reference_compatible_p (TREE_TYPE (totype), extype))
-	      error_at (loc, "binding reference of type %qH to %qI "
-			"discards qualifiers", totype, extype);
+	      d.error_at (loc, "binding reference of type %qH to %qI "
+			  "discards qualifiers", totype, extype);
 	    else
 	      gcc_unreachable ();
-	    maybe_print_user_conv_context (convs);
+	    maybe_print_user_conv_context (&d, convs);
 	    if (fn)
-	      inform (DECL_SOURCE_LOCATION (fn),
-		      "  initializing argument %P of %qD", argnum, fn);
+	      d.inform (DECL_SOURCE_LOCATION (fn),
+			"  initializing argument %P of %qD", argnum, fn);
 	    return error_mark_node;
 	  }
 
@@ -7922,10 +7959,11 @@ build_over_call (struct z_candidate *cand, int flags, tsubst_flags_t complain)
 	{
 	  if (complain & tf_error)
 	    {
-	      if (permerror (input_location, "passing %qT as %<this%> "
-			     "argument discards qualifiers",
-			     TREE_TYPE (argtype)))
-		inform (DECL_SOURCE_LOCATION (fn), "  in call to %qD", fn);
+	      diagnostic_group d;
+	      if (d.permerror (input_location, "passing %qT as %<this%> "
+			       "argument discards qualifiers",
+			       TREE_TYPE (argtype)))
+		d.inform (DECL_SOURCE_LOCATION (fn), "  in call to %qD", fn);
 	    }
 	  else
 	    return error_mark_node;
@@ -9203,11 +9241,12 @@ build_new_method_call_1 (tree instance, tree fns, vec<tree, va_gc> **args,
 
       basetype = DECL_CONTEXT (fn);
       name = constructor_name (basetype);
-      if (permerror (input_location,
-		     "cannot call constructor %<%T::%D%> directly",
-		     basetype, name))
-	inform (input_location, "for a function-style cast, remove the "
-		"redundant %<::%D%>", name);
+      diagnostic_group d;
+      if (d.permerror (input_location,
+		       "cannot call constructor %<%T::%D%> directly",
+		       basetype, name))
+	d.inform (input_location, "for a function-style cast, remove the "
+		  "redundant %<::%D%>", name);
       call = build_functional_cast (basetype, build_tree_list_vec (user_args),
 				    complain);
       return call;
@@ -9341,12 +9380,15 @@ build_new_method_call_1 (tree instance, tree fns, vec<tree, va_gc> **args,
     {
       if (complain & tf_error)
 	{
+	  diagnostic_group d;
 	  if (!COMPLETE_OR_OPEN_TYPE_P (basetype))
+	    // FIXME: use d?
 	    cxx_incomplete_type_error (instance, basetype);
 	  else if (optype)
-	    error ("no matching function for call to %<%T::operator %T(%A)%#V%>",
-		   basetype, optype, build_tree_list_vec (user_args),
-		   TREE_TYPE (instance));
+	    d.error ("no matching function for call to "
+		     "%<%T::operator %T(%A)%#V%>",
+		     basetype, optype, build_tree_list_vec (user_args),
+		     TREE_TYPE (instance));
 	  else
 	    {
 	      tree arglist = build_tree_list_vec (user_args);
@@ -9361,11 +9403,11 @@ build_new_method_call_1 (tree instance, tree fns, vec<tree, va_gc> **args,
 		errname = lookup_template_function (errname, explicit_targs);
 	      if (skip_first_for_error)
 		arglist = TREE_CHAIN (arglist);
-	      error ("no matching function for call to %<%T::%s%E(%A)%#V%>",
-		     basetype, &"~"[!twiddle], errname, arglist,
-		     TREE_TYPE (instance));
+	      d.error ("no matching function for call to %<%T::%s%E(%A)%#V%>",
+		       basetype, &"~"[!twiddle], errname, arglist,
+		       TREE_TYPE (instance));
 	    }
-	  print_z_candidates (location_of (name), candidates);
+	  print_z_candidates (&d, location_of (name), candidates);
 	}
       call = error_mark_node;
     }
@@ -9384,13 +9426,14 @@ build_new_method_call_1 (tree instance, tree fns, vec<tree, va_gc> **args,
 	      arglist = build_tree_list_vec (user_args);
 	      if (skip_first_for_error)
 		arglist = TREE_CHAIN (arglist);
+	      diagnostic_group d;
 	      if (!any_strictly_viable (candidates))
-		error ("no matching function for call to %<%s(%A)%>",
-		       pretty_name, arglist);
+		d.error ("no matching function for call to %<%s(%A)%>",
+			 pretty_name, arglist);
 	      else
-		error ("call of overloaded %<%s(%A)%> is ambiguous",
-		       pretty_name, arglist);
-	      print_z_candidates (location_of (name), candidates);
+		d.error ("call of overloaded %<%s(%A)%> is ambiguous",
+			 pretty_name, arglist);
+	      print_z_candidates (&d, location_of (name), candidates);
 	      if (free_p)
 		free (pretty_name);
 	    }
@@ -10290,11 +10333,14 @@ joust (struct z_candidate *cand1, struct z_candidate *cand2, bool warn,
 	  tree source = source_type (w->convs[0]);
 	  if (INDIRECT_TYPE_P (source))
 	    source = TREE_TYPE (source);
-	  if (warning (OPT_Wconversion, "choosing %qD over %qD", w->fn, l->fn)
-	      && warning (OPT_Wconversion, "  for conversion from %qH to %qI",
-			  source, w->second_conv->type)) 
+	  diagnostic_group d;
+	  if (d.warning (OPT_Wconversion, "choosing %qD over %qD", w->fn, l->fn)
+	      && d.warning (OPT_Wconversion, "  for conversion from %qH to %qI",
+			    source, w->second_conv->type))
 	    {
-	      inform (input_location, "  because conversion sequence for the argument is better");
+	      d.inform (input_location,
+			"  because conversion sequence for the argument is"
+			" better");
 	    }
 	}
       else
@@ -10517,14 +10563,15 @@ joust (struct z_candidate *cand1, struct z_candidate *cand2, bool warn,
 		{
 		  if (complain & tf_error)
 		    {
-		      if (permerror (input_location,
-				     "default argument mismatch in "
-				     "overload resolution"))
+		      diagnostic_group d;
+		      if (d.permerror (input_location,
+				       "default argument mismatch in "
+				       "overload resolution"))
 			{
-			  inform (DECL_SOURCE_LOCATION (cand1->fn),
-				  " candidate 1: %q#F", cand1->fn);
-			  inform (DECL_SOURCE_LOCATION (cand2->fn),
-				  " candidate 2: %q#F", cand2->fn);
+			  d.inform (DECL_SOURCE_LOCATION (cand1->fn),
+				    " candidate 1: %q#F", cand1->fn);
+			  d.inform (DECL_SOURCE_LOCATION (cand2->fn),
+				    " candidate 2: %q#F", cand2->fn);
 			}
 		    }
 		  else
@@ -10568,12 +10615,13 @@ tweak:
 	    return 0;
 	  if (warn)
 	    {
-	      pedwarn (input_location, 0,
-	      "ISO C++ says that these are ambiguous, even "
-	      "though the worst conversion for the first is better than "
-	      "the worst conversion for the second:");
-	      print_z_candidate (input_location, _("candidate 1:"), w);
-	      print_z_candidate (input_location, _("candidate 2:"), l);
+	      diagnostic_group d;
+	      d.pedwarn (input_location, 0,
+			 "ISO C++ says that these are ambiguous, even "
+			 "though the worst conversion for the first is better "
+			 "than the worst conversion for the second:");
+	      print_z_candidate (&d, input_location, _("candidate 1:"), w);
+	      print_z_candidate (&d, input_location, _("candidate 2:"), l);
 	    }
 	  else
 	    add_warning (w, l);
